/**
 * Created by AlgoOy on 9/19/2022.
 */

#include "bsp_clkconfig.h"
#include "stm32f1xx_hal_rcc.h"

void SystemClock_Config(uint32_t RCC_OSCILLATORTYPE, uint32_t RCC_PULL_MUL) {
    RCC_ClkInitTypeDef clkinitstruct = {0};
    RCC_OscInitTypeDef oscinitstruct = {0};

    /* Enable HSE Oscillator and activate PLL with HSE as source */
    oscinitstruct.OscillatorType = RCC_OSCILLATORTYPE;
    oscinitstruct.HSEState = RCC_HSE_ON;
    oscinitstruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
    oscinitstruct.PLL.PLLState = RCC_PLL_ON;
    oscinitstruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
    oscinitstruct.PLL.PLLMUL = RCC_PULL_MUL;
    if (HAL_RCC_OscConfig(&oscinitstruct) != HAL_OK) {
        /* Initialization Error */
        while (1);
    }

    /* Select PLL as system clock source and configure the HCLK, PCLK1 and PCLK2
     * clocks dividers */
    clkinitstruct.ClockType = (RCC_CLOCKTYPE_SYSCLK | RCC_CLOCKTYPE_HCLK |
                               RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2);
    clkinitstruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;                   // 72MHz
    clkinitstruct.AHBCLKDivider = RCC_SYSCLK_DIV1;                          // 72MHz
    clkinitstruct.APB1CLKDivider = RCC_HCLK_DIV2;                           // 36 MHz
    clkinitstruct.APB2CLKDivider = RCC_HCLK_DIV1;                           // 72 MHz
    if (HAL_RCC_ClockConfig(&clkinitstruct, FLASH_LATENCY_2) != HAL_OK) {
        /* Initialization Error */
        while (1);
    }
}
