/**
 * Created by AlgoOy on 9/18/2022.
 */

#include "bsp_key.h"

void Key_GPIO_Config(void) {
    /* Define a struct of type GPIO_InitTypeDef */
    GPIO_InitTypeDef GPIO_InitStruct;

    /* Enable the GPIO_Key Clock */
    KEY2_GPIO_CLK_ENABLE();
    KEY3_GPIO_CLK_ENABLE();

    /* Select the GPIO_Key Pin */
    GPIO_InitStruct.Pin = KEY2_PIN;

    /* Set the GPIO_Key Mode */
    GPIO_InitStruct.Mode = GPIO_MODE_INPUT;

    /* Set the GPIO_Key Pull */
    GPIO_InitStruct.Pull = GPIO_NOPULL;

    /* Initialize the GPIO_Key */
    HAL_GPIO_Init(KEY2_GPIO_PORT, &GPIO_InitStruct);

    /* Select the GPIO_Key Pin */
    GPIO_InitStruct.Pin = KEY3_PIN;

    /* Initialize the GPIO_Key */
    HAL_GPIO_Init(KEY3_GPIO_PORT, &GPIO_InitStruct);
}

/* 若按键的硬件没有做消抖处理，需要在这个Key_Scan函数中做软件滤波，防止波纹抖动引起误触发 */
uint8_t Key_Scan(GPIO_TypeDef *GPIOx, uint16_t GPIO_Pin) {
    /* If the key is pressed */
    if (HAL_GPIO_ReadPin(GPIOx, GPIO_Pin) == KEY_ON) {
        /* Waiting for the key to be released */
        while (HAL_GPIO_ReadPin(GPIOx, GPIO_Pin) == KEY_ON);
        return KEY_ON;
    } else {
        return KEY_OFF;
    }
}