/**
 * Created by AlgoOy on 9/18/2022.
 * @file    bsp_led.c
 * @author  AlgoOy
 * @version V1.0
 * @date    2022-xx-xx
 * @brief   LED API
 */

/* 只需要在CMakeLists.txt文件中包含头文件目录，就可以不带路径访问头文件 */
#include "bsp_led.h"

/**
 * @brief   初始化控制LED的IO
 * @param   无
 * @retval  无
*/
void LED_GPIO_Config(void) {
    /* Define a struct of type GPIO_InitTypeDef */
    GPIO_InitTypeDef GPIO_InitStruct;

    /* Enable the GPIO_LED Clock */
    LED1_GPIO_CLK_ENABLE();
    LED2_GPIO_CLK_ENABLE();
    LED3_GPIO_CLK_ENABLE();

    /* Select the GPIO_LED pin */
    GPIO_InitStruct.Pin = LED1_PIN;

    /* Set the GPIO_LED pin mode to output */
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;

    /* Set the GPIO_LED pin output type to push-pull */
    GPIO_InitStruct.Pull = GPIO_PULLUP;

    /* Set the GPIO_LED pin output speed to high */
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;

    /* Call HAL API to initialize the GPIO_LED pin */
    HAL_GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStruct);

    /* Select the GPIO_LED pin */
    GPIO_InitStruct.Pin = LED2_PIN;

    /* Call HAL API to initialize the GPIO_LED pin */
    HAL_GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStruct);

    /* Select the GPIO_LED pin */
    GPIO_InitStruct.Pin = LED3_PIN;

    /* Call HAL API to initialize the GPIO_LED pin */
    HAL_GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStruct);

    /* Turn off all LEDs */
    LED_OFF;
}
